Subject: Re: kgdb/Sandpoint -- patch & help needed

From: Murray Jensen <[email-masked]>
Date: Tue, 19 Sep 2000 14:39:17 +1100

On Mon, 18 Sep 2000 17:16:27 +0300, Alex Shnitman <[email-masked]> writes:
>... However, with this patch the kernel
>hangs right after saying "Now booting the kernel". I don't even see
>how these changes could affect the boot process so early.

Aha! I was caught by this. When you enable CONFIG_KGDB, a breakpoint is
executed in setup_arch() which is just about the first thing the kernel
does.

The sequence is (very!) roughly (and for the 8xx embedded platform):

_start()
	identify_machine()
	MMU_init()
	start_kernel()
		lock_kernel()
		setup_arch()
			set_debug_traps()	| ifdef CONFIG_KGDB
			breakpoint()		|
			...
		parse_options()
		trap_init()
		init_IRQ()
		...

Solution? Simply start gdb on your host machine and do the following:

	set remotebaud BBBBBB	(if required)

	target remote /dev/...	(serial port on host connected to
				 target kgdb serial port)
	continue

and your kernel will fire up again (I kicked myself when I realised what
was going on). Cheers!
								Murray...

** Sent via the linuxppc-embedded mail list. See http://lists.linuxppc.org/